#include <stdio.h>
#include <string>
#include <iostream>
#include <sstream>
#include <cstring>

#ifdef FLASHPROIMOTION
#include "../FlashProiMOTION-Dll.h"
#endif

#ifdef GANGPROIMOTION
#include "../GangProiMOTION-Dll.h"
#endif

using namespace std;
int main(int argc, char* argv[])
{
  int st;

  string input = "*# *";
  if(argc < 2)
  {
    cout<< "Usage: <config> <code (optional)>" << endl;
    return 1;
  }

  F_Trace_ON();
  cout << "F_OpenInstancesAndFPAs : " << dec <<   F_OpenInstancesAndFPAs((char *)input.c_str()) << endl;
  cout << "F_Get_FPA_SN : " << F_Get_FPA_SN(1) << endl;
  cout << "F_Set_FPA_index : " << dec << F_Set_FPA_index (0) << endl;
  cout << "F_Initialization : " << dec << F_Initialization() << endl;
  cout << "API Version " << hex << (0xFFF & F_DLLTypeVer()) << endl;
  cout << "Multi Version " << hex << (0xFFF & F_Multi_DLLTypeVer()) << endl;
  F_Set_FPA_index(1);
  cout << "F_ConfigFileLoad : " << dec << F_ConfigFileLoad( argv[1] ) << endl;
  cout << F_Report_Message() << endl;

  if(argc >= 3) {
    //Code files can be loaded implicitly from config file if CodeFileName1/2/3... params are specified
    //To process more than 1 file, use F_ReadCodeFile for first file, then F_AppendCodeFile for second, third, etc.
    cout << "F_ReadCodeFile : " << dec << F_ReadCodeFile( argv[2] ) << endl;
    cout << F_Report_Message() << endl;
  }

  cout << "F_Verify_Access_to_MCU : " << dec << F_Verify_Access_to_MCU() << endl;

  //Optional factory erase; useful if MCU might be locked.
  //cout << "F_Clear_Locked_Device : " << dec << F_Clear_Locked_Device() << endl;
  //cout << F_Report_Message() << endl;

  cout << "F_AutoProgram : " << dec << F_AutoProgram() << endl;
  cout << F_Report_Message() << endl;


  F_Trace_OFF();
   return 0;
}
